; ***** BEGIN LICENSE BLOCK *****
; * Copyright (C) 2007  Stanislav Ievlev <inger@altlinux.org>
; *
; * This program is free software; you can redistribute it and/or modify
; * it under the terms of the GNU General Public License as published by
; * the Free Software Foundation; either version 2 of the License, or
; * (at your option) any later version.
; *
; * This program is distributed in the hope that it will be useful,
; * but WITHOUT ANY WARRANTY; without even the implied warranty of
; * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; * GNU General Public License for more details.
; *
; * You should have received a copy of the GNU General Public License
; * along with this program; if not, write to the Free Software
; * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
; ***** END LICENSE BLOCK *****

(document:surround "/std/frame")
(document:envelop with-translation _ "installer-junior")

(define all-packages (make-cell '()))

(define (summary x)
  (cons (woo-get-option x 'summary (woo-get-option x 'name)) #f))

(define (name x y)
  (and (cdr x)
       (woo-get-option y 'name)))

(define (load-packages)
  (woo-catch
   (thunk (woo-list "/apt-profile/install3"))
   (lambda(reason)
     (document:popup-critical (_ "unable to read package installation profile") 'ok)
     '())))

(define (write-update)
  (woo-catch/message
   (thunk (woo-write "/apt-get" 'job "update" 'packages "  ")
          (woo-write "/autoinstall/apt-get" 'job "update" 'packages "  "))))

(define (skip-step)
  (if (eq? (global 'frame:direction) 'next)
      (frame:next)
      (frame:back)))

(hbox
 (spacer)
 (groupbox (_ "Select packages you want to install")
           max-width 300
           max-height 300
           (document:id packages (checklist)))
 (spacer))

(define (install-packages lst)
  (and  (eq? 'ok (document:popup '/apt
                                 'packages lst
                                 'job "install"))
        (woo-write "/autoinstall/apt-get"
                   'packages (string-join lst " ")
                   'job "install")))

(frame:on-next
 (thunk
  (or (null? (cell-ref all-packages))
      (let ((install-list
             (filter-map name
                         (packages checklist-rows)
                         (cell-ref all-packages))))
        (and (pair? install-list)
             (or (install-packages install-list) 'cancel))))))

(document:root
 (when loaded
   (write-update)
   (let ((packages-list (load-packages)))
     (cell-set! all-packages packages-list)
     (cond ((null? packages-list)
            (skip-step))
           (#t
            (packages checklist-rows (map summary packages-list)))))))
